// Copyright 2024 Matthew Rich <matthewrich.conf@gmail.com>. All rights reserved.

package containerlog

import (
	"github.com/stretchr/testify/assert"
	"testing"
)

func TestStreamType(t *testing.T) {
	for _, v := range []struct{ expected error; value StreamType } {
		{ expected: nil, value: 0x0 },
		{ expected: nil, value: 0x1 },
		{ expected: nil, value: 0x2 },
		{ expected: ErrInvalidStreamType, value: 0x3 },
		{ expected: ErrInvalidStreamType, value: 0x4 },
	} {
		assert.ErrorIs(t, v.value.Validate(), v.expected)
	}
}
