// Copyright 2024 Matthew Rich <matthewrich.conf@gmail.com>. All rights reserved.


package folio

import (
	"github.com/stretchr/testify/assert"
	"testing"
)


func TestEventType(t *testing.T) {
	for _, v := range []struct{ et EventType; expected error } {
		{ et: EventType("load"), expected: nil },
		{ et: EventType("create"), expected: nil },
		{ et: EventType("read"), expected: nil },
		{ et: EventType("update"), expected: nil },
		{ et: EventType("delete"), expected: nil },
		{ et: EventType("error"), expected: nil },
		{ et: EventType("foo"), expected: ErrUnknownEventType },
	} {
		assert.ErrorIs(t, v.et.Validate(), v.expected)
	}
}

func TestEventTypeSet(t *testing.T) {
	var et EventType
	assert.Nil(t, et.Set(EventTypeLoad))
}
